/*Copyright 2006 Mathieu Lemire*/
#include<iostream>
#include<string>
#include<fstream>
#include<sstream>
#include<stdlib.h>

using namespace std;

class Genotypes
{

  int nLoci;

  int nIndividuals;

  int *** alleles;

  bool * filled;

public:

  Genotypes( int nl, int ni ){
    
    int i,j;
    
    nLoci = nl;
    nIndividuals = ni;

    filled = new bool [ nIndividuals ];

    alleles = new int ** [ nIndividuals ];

    for( i=0; i<nIndividuals; i++){
      filled[i]=0;    
    }    
  

  }

  ~Genotypes(){
    delete [] filled;
    delete [] alleles;
  }

  void Alloc (int s, int e){
    int i,j;
    for( i=s; i<e; i++){

      alleles[i] = new int * [nLoci];
      for( j=0; j<nLoci; j++){
	alleles[i][j] = new int [2];
	alleles[i][j][0] = -1;
	alleles[i][j][1] = -1;
      }
    }    
    
  }

  void FreeMem( int s, int e ){
    int i,j;
    for( i=s; i<e; i++){
      for( j=0; j<nLoci; j++){
	delete [] alleles[i][j];
      }
      delete [] alleles[i];
    }
  }


  void SetAllele(int ind,int loc,int chr,int value){ //chr 0 from father
    alleles[ind][loc][chr] = value;
  }

  void Filled (int i, bool value = 1){
    filled[i] = value;
  }

  bool IsFilled( int i ){
    return filled[i];
  }

  int  Alleles (int ind,int loc,int chr ){
    return  alleles[ind][loc][chr];
  }

  int NLoci(){
    return nLoci;
  }

  int NIndividuals(){
    return nIndividuals;
  }

};
